#ifndef __MOZILLABOOKMARK_H
#define __MOZILLABOOKMARK_H

#include	<stdio.h>
#include	<time.h>

class MozillaBookmark {
private:
	char *m_id;				// fBNgID
	char *m_charset;		// R[h
	time_t m_check;			// ŏIXVmF
	char *m_Firefoxicon;	// ACR(Firefox)
	char *m_FeedUrl;		// RSStB[hURL
	char *m_schedule;		// XVmFXPW[
	int m_group;			// tH_O[v̏ꍇ1
	int m_LinkbarFolder;	// tH_Personal toolbaȑꍇ1
	bool m_NewSearchFolder;	// tH_New Internet Search Foldeȑꍇtrue
	bool m_NewBookmarkFolder;	// tH_New Bookmark Foldeȑꍇtrue
	char *m_micsum_gen_uri;	// Micro summary generate URL(Firefox 2)
	char *m_micsum_expiration;	// Micro summary expiration(Firefox 2)
	char *m_generatedTitle;	// Generated title(Firefox 2)
	char *m_HRName;			// ؂̃x(Mozilla 1.4)
	bool m_webPanel;		// WEB_PANELݒ肳Ăꍇ1
	char *m_icon_uri;		// ACRURI(Gran Paradiso)

	// ǂݍłubN}[N̎
	static int m_mozVersion[2];	// 0:Netscape 4/1:Netscape 6,7/Mozilla/2:Mozilla 1.4(ǂݎΏۃuEŨo[W)/3:Mozilla Firefox 1.0 and later
	// o͌`
	static int m_outputType[2];			// 0:Netscape 4/1:Netscape 6,7/Mozilla(R}hCŐݒ肳ꂽo͑ΏۃuEU)/2:Mozilla Firefox(\)
	static int m_spaces;
	static bool m_UTF8[2];		// UTF-8ǂH
	static FILE *cs_fpo;		// ubN}[No͗pt@C|C^

	void _init();
	void spput(FILE *fp, int spaces);
	void putname(FILE *fp,wchar_t *name);
	void putname2(FILE *fp,char *name);
	void putDescription(FILE *fp,char *name);
	void putShortcut(FILE *fp,char *name);

protected:
	void _copy(const MozillaBookmark &src);
	void copy(const MozillaBookmark &src);

public:
	/* EʁEj */
	MozillaBookmark(void);
	MozillaBookmark(const MozillaBookmark &src);
	virtual ~MozillaBookmark();

	MozillaBookmark & operator = (const MozillaBookmark &src);

	void reset(void);

	/* MozillaŗL */
	char *getID(void) const { return m_id; };
	char *setID(const char *item);
	char *getCharset(void) const { return m_charset; };
	char *setCharset(const char *item);
	time_t getCheck(void) const { return m_check; };
	time_t setCheck(const char *item);
	time_t setCheck(const time_t time) { m_check = time;return m_check; };
	char *getFirefoxIcon(void) const { return m_Firefoxicon; };
	char *setFirefoxIcon(const char *item);
	char *getFeedUrl(void) const { return m_FeedUrl; };
	char *setFeedUrl(const char *item);
	char *getSchedule(void) const { return m_schedule; };
	char *setSchedule(const char *item);
	int getGroup(void) const { return m_group; };
	int setGroup(const int status){ m_group = status;return m_group; };
	// ̃vpeBOpera 6̃ubN}[Nɂ̂ō킹Ă݂B
	// 0.9.8ɂ͂Ȃ悤ȋĈB
	int getLinkbarFolder(void) const { return m_LinkbarFolder; };
	int setLinkbarFolder(const int status) {m_LinkbarFolder = status;return m_LinkbarFolder;};
	bool getNewSearchFolder(void) const { return m_NewSearchFolder; };
	bool setNewSearchFolder(const bool status) {m_NewSearchFolder = status;return m_NewSearchFolder;};
	bool getNewBookmarkFolder(void) const { return m_NewBookmarkFolder; };
	bool setNewBookmarkFolder(const bool status) {m_NewBookmarkFolder = status;return m_NewBookmarkFolder;};
	bool getWebPanel(void) const { return m_webPanel; };
	bool setWebPanel(const bool status) {m_webPanel = status;return m_webPanel;};

	char *getHRName(void) const { return m_HRName; };
	char *setHRName(const char *item);

	// for Micro summary (Firefox 2)
	char *getMicsum_gen_uri(void) const { return m_micsum_gen_uri; };
	char *setMicsum_gen_uri(const char *item);
	char *getMicsum_expiration(void) const { return m_micsum_expiration; };
	char *setMicsum_expiration(const char *item);
	char *getGeneratedTitle(void) const { return m_generatedTitle; };
	char *setGeneratedTitle(const char *item);
	char *getIconUri(void) const { return m_icon_uri; };
	char *setIconUri(const char *item);

	/* o͌`̎擾Ǝw */
	static int getBrowserType(int no) { return m_outputType[no]; };
	static void setBrowserType(int no,int type){ m_outputType[no] = type;};
	/* ǂݍłubN}[N̎ނ̎w */
	static int getBrowserVersion(int no){ return m_mozVersion[no];};
	static void setBrowserVersion(int no,int type){ m_mozVersion[no] = type;};
	
	static bool isUTF8(int no){ return m_UTF8[no];};
	static bool setUTF8(int no,const bool mode){ m_UTF8[no] = mode;return m_UTF8[no];};


};

#endif	// __BOOKMARK_H
